/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * CardView.java
 *
 * Created on Dec 6, 2010, 12:52:09 PM
 */

package GUI;

import Main.Main;
import Game.Card;
import Game.Hand;

/**
 *
 * @author A.M. Bosch, s080431
 */
public class CardView extends javax.swing.JPanel {

    private volatile boolean toChooseCard = false;
    private volatile Card selectedCard;

    private volatile boolean toPassOrPlay = false;
    private volatile boolean passOrPlay;

    private volatile boolean calledHonour = false;
    //Constructor
    public CardView() {
        initComponents();
        west.setVertical(true);
        north.setVertical(false);
        east.setVertical(true);
        repaint();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        focusPlayer = new GUI.FocusCardView();
        west = new GUI.NoFocusCardView();
        north = new GUI.NoFocusCardView();
        east = new GUI.NoFocusCardView();
        tableau = new GUI.Tableau();
        trumpView = new GUI.TrumpView();
        jLabelNorth = new javax.swing.JLabel();
        jLabelWest = new javax.swing.JLabel();
        jLabelEast = new javax.swing.JLabel();
        jLabelSouth = new javax.swing.JLabel();

        setPreferredSize(new java.awt.Dimension(750, 900));
        setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        focusPlayer.setPreferredSize(new java.awt.Dimension(400, 220));

        javax.swing.GroupLayout focusPlayerLayout = new javax.swing.GroupLayout(focusPlayer);
        focusPlayer.setLayout(focusPlayerLayout);
        focusPlayerLayout.setHorizontalGroup(
            focusPlayerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        focusPlayerLayout.setVerticalGroup(
            focusPlayerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 220, Short.MAX_VALUE)
        );

        add(focusPlayer, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 680, -1, -1));

        west.setPreferredSize(new java.awt.Dimension(120, 430));

        javax.swing.GroupLayout westLayout = new javax.swing.GroupLayout(west);
        west.setLayout(westLayout);
        westLayout.setHorizontalGroup(
            westLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 120, Short.MAX_VALUE)
        );
        westLayout.setVerticalGroup(
            westLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 444, Short.MAX_VALUE)
        );

        add(west, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 250, -1, 444));

        north.setPreferredSize(new java.awt.Dimension(400, 185));

        javax.swing.GroupLayout northLayout = new javax.swing.GroupLayout(north);
        north.setLayout(northLayout);
        northLayout.setHorizontalGroup(
            northLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        northLayout.setVerticalGroup(
            northLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 193, Short.MAX_VALUE)
        );

        add(north, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 30, -1, 193));

        east.setPreferredSize(new java.awt.Dimension(120, 430));

        javax.swing.GroupLayout eastLayout = new javax.swing.GroupLayout(east);
        east.setLayout(eastLayout);
        eastLayout.setHorizontalGroup(
            eastLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 120, Short.MAX_VALUE)
        );
        eastLayout.setVerticalGroup(
            eastLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 441, Short.MAX_VALUE)
        );

        add(east, new org.netbeans.lib.awtextra.AbsoluteConstraints(600, 250, -1, 441));

        tableau.setPreferredSize(new java.awt.Dimension(420, 410));

        javax.swing.GroupLayout tableauLayout = new javax.swing.GroupLayout(tableau);
        tableau.setLayout(tableauLayout);
        tableauLayout.setHorizontalGroup(
            tableauLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 426, Short.MAX_VALUE)
        );
        tableauLayout.setVerticalGroup(
            tableauLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 412, Short.MAX_VALUE)
        );

        add(tableau, new org.netbeans.lib.awtextra.AbsoluteConstraints(160, 250, 426, 412));

        trumpView.setPreferredSize(new java.awt.Dimension(120, 185));

        javax.swing.GroupLayout trumpViewLayout = new javax.swing.GroupLayout(trumpView);
        trumpView.setLayout(trumpViewLayout);
        trumpViewLayout.setHorizontalGroup(
            trumpViewLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 120, Short.MAX_VALUE)
        );
        trumpViewLayout.setVerticalGroup(
            trumpViewLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 185, Short.MAX_VALUE)
        );

        add(trumpView, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 715, -1, -1));

        jLabelNorth.setFont(new java.awt.Font("Arial Black", 0, 12));
        jLabelNorth.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabelNorth.setText("jLabel1");
        add(jLabelNorth, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 40, 140, -1));

        jLabelWest.setFont(new java.awt.Font("Arial Black", 0, 12));
        jLabelWest.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelWest.setText("jLabel1");
        add(jLabelWest, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 230, 120, -1));

        jLabelEast.setFont(new java.awt.Font("Arial Black", 0, 12));
        jLabelEast.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabelEast.setText("jLabel1");
        add(jLabelEast, new org.netbeans.lib.awtextra.AbsoluteConstraints(600, 230, 120, -1));

        jLabelSouth.setFont(new java.awt.Font("Arial Black", 0, 12));
        jLabelSouth.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabelSouth.setText("jLabel1");
        add(jLabelSouth, new org.netbeans.lib.awtextra.AbsoluteConstraints(590, 880, 140, -1));
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private GUI.NoFocusCardView east;
    private GUI.FocusCardView focusPlayer;
    private javax.swing.JLabel jLabelEast;
    private javax.swing.JLabel jLabelNorth;
    private javax.swing.JLabel jLabelSouth;
    private javax.swing.JLabel jLabelWest;
    private GUI.NoFocusCardView north;
    private GUI.Tableau tableau;
    private GUI.TrumpView trumpView;
    private GUI.NoFocusCardView west;
    // End of variables declaration//GEN-END:variables


    /**
     * Updates the CardView window to display the hands given.
     * hand[0] corresponds to the human player
     * hand[1] corresponds to the west player
     * hand[2] corresponds to the north player
     * hand[3] corresponds to the east player
     * @param hand HandArray[4] to be displayed.
     */
    public void updateCardView(Hand hand[]){
        focusPlayer.updateFocusCardView(hand[0]);
        west.updateNoFocusCardView(hand[1]);
        north.updateNoFocusCardView(hand[2]);
        east.updateNoFocusCardView(hand[3]);
    }

    /**
     * Updates the CardView windows to display the hand of a certain player
     * playerID:    0 -> south
     *              1 -> west
     *              2 -> north
     *              3 -> east
     * @param playerID
     * @param hand
     */
    public void updateCardViewPlayer(int playerID,Hand hand){
        switch(playerID){
            case 0:
                focusPlayer.updateFocusCardView(hand);
                break;
            case 1:
                west.updateNoFocusCardView(hand);
                break;
            case 2:
                north.updateNoFocusCardView(hand);
                break;
            case 3:
                east.updateNoFocusCardView(hand);
                break;
            default:
                System.err.println("Invalid playerID argument in updateCardViewPlayer()");
        }
    }

    /**
     * Updates the tableau window to display the current trick, cards that shouldn't be displayed
     * are assumed to have value null.
     */
    public void updateTableau(Game.Trick trick){
        tableau.updateTableau(trick);
    }
    
    /**
     * Sets the trump picture
     * @param Trump: Card whom the suit will be the trump colour.
     */
    public void setCurrentTrump(Card Trump){
        trumpView.setTrump(Trump);
    }

    /**
     * Sets the trump picture
     * @param suit: suit that is designated as trump colour
     */
    public void setCurrentTrump(Card.Suit suit){
        trumpView.setTrump(suit);
    }

    /**
     * Determines whether Human wants to call honour.
     * @return True if Human wants to call honour.
     */
    public boolean promptHonour(){
        setInfoText("You have 3 seconds to call honour\nif there is any.");
        
        Main.jFrameMain.controlPanel.enableCallHonour(true);
        setCalledHonour(false);

        try {
            for (int i=3000/100; i>0; i--) {
                Thread.sleep(100);

                if (getCalledHonour())
                    break;
            }
        } catch (InterruptedException e) {

        }

        Main.jFrameMain.controlPanel.enableCallHonour(false);

        return getCalledHonour();
    }

     /**
     * Prompts the human player to play a card, waits until a card is selected and then returns this card.
     * @return Card
     */
    public Card playCard() {
        setInfoText("Play a card from your hand by\nclicking on it.");
        waitForCardSelect();
        
        return getSelectedCard();
    }

     /**
     * Prompts the player to pass or play, waits until a choice is made and then returns true = play, false = pass.
     * @return: True if Human wants to play.
     */
    public boolean passOrPlay() {
        Main.jFrameMain.controlPanel.enablePassOrPlay(true);
        setInfoText("Do you want to play or pass with the\ntrump suit on your left?");
        waitForPassOrPlay();
        Main.jFrameMain.controlPanel.enablePassOrPlay(false);
        setInfoText("You have opted to " + (getPassOrPlay() ? "play" : "pass") + ".");
        
        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
        }

        return getPassOrPlay();
    }

     /**
     * Prompts the player to select a Trump color by clicking on a card in the hand, waits until the choice is made
     * and then returns the selected trump suit.
     * @return Returns the trump suit that is picked by the player.
     */
    public Card.Suit selectTrumpColour() {
        setInfoText("All players after you have passed.\nSelect a trump suit by picking a card\nfrom your hand.");
        waitForCardSelect();
        setInfoText("You have selected " + getSelectedCard().getSuit().toString() + " as\nthe trump suit.");

        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
        }
        
        return getSelectedCard().getSuit();
    }

    public void setToChooseCard(boolean toChooseCard) {
        this.toChooseCard = toChooseCard;
    }

    public boolean getToChooseCard() {
        return toChooseCard;
    }

    public Card getSelectedCard() {
        return selectedCard;
    }

    public void setSelectedCard(Card selectedCard) {
        this.selectedCard = selectedCard;
    }
    
    public boolean getToPassOrPlay() {
        return toPassOrPlay;
    }

    public void setToPassOrPlay(boolean toPassOrPlay) {
        this.toPassOrPlay = toPassOrPlay;
    }

    public boolean getPassOrPlay() {
        return passOrPlay;
    }

    public void setPassOrPlay(boolean passOrPlay) {
        this.passOrPlay = passOrPlay;
    }


    public boolean getCalledHonour() {
        return calledHonour;
    }

    public void setCalledHonour(boolean calledHonour) {
        this.calledHonour = calledHonour;
    }

    /*
     * Waits until a card is clicked by the player.
     * By setting toChooseCard to true and checking every 100ms if it is set to false.
     */
    private void waitForCardSelect () {
        setToChooseCard(true);

        while (getToChooseCard()) {
            try {
                Thread.sleep(100);          // Prevent CPU hogging
            } catch (InterruptedException e) {

            }
        }
    }

    /*
     * Waits until the passButton or playButton is clicked by the player.
     * By setting toPassOrPlay to true and checking every 100ms if it is set to false.
     */
    private void waitForPassOrPlay () {
        setToPassOrPlay(true);

        while (getToPassOrPlay()) {
            try {
                Thread.sleep(100);          // Prevent CPU hogging
            } catch (InterruptedException e) {

            }
        }
    }

    /*
     * Sets the info text in the controlpanel to the inputstring parameter.
     */
    public void setInfoText(String infoText) {
        Main.jFrameMain.controlPanel.jTextArea.setText(infoText);
    }

    public void setPlayerNames (){
        jLabelSouth.setText(Main.jFrameMain.mainMenu.getPlayerName(0));
        jLabelWest.setText(Main.jFrameMain.mainMenu.getPlayerName(1));
        jLabelNorth.setText(Main.jFrameMain.mainMenu.getPlayerName(2));
        jLabelEast.setText(Main.jFrameMain.mainMenu.getPlayerName(3));
    }
}
