/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ScoreView.java
 *
 * Created on Dec 6, 2010, 12:52:20 PM
 */

package GUI;

import Game.Match;
import java.awt.Font;
import Score.Score;

/**
 *
 * @author A.M. Bosch, s080431
 */
public class ScoreView extends javax.swing.JPanel {
    
    private Font plainFont = new Font("arial", Font.PLAIN, 12);

    /** Creates new form ScoreView */
    public ScoreView() {
        initComponents();

        clearScoreTable();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jScoreTable = new javax.swing.JTable();

        jScoreTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Team 1", "Honour", "Team 2", "Honour"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScoreTable.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jScoreTable.setShowHorizontalLines(false);
        jScoreTable.getTableHeader().setResizingAllowed(false);
        jScoreTable.getTableHeader().setReorderingAllowed(false);
        jScrollPane1.setViewportView(jScoreTable);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 394, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 644, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(20, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable jScoreTable;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables

    /*
     * Update the score table up to a specific game
     */
    public void updateScoreTable(Score scoreData, int upToGame) {

        int rowPointer = 1;
        
        if (upToGame < 0) {
            clearScoreTable();
            return;
        }

        // loop through games (max: 16)
        for (int n = 0; n <= upToGame; n++) {

            // for each game, get both teams
            for (int j = 0; j < 2; j++) {

                //Score (use * 2 as a correction at team 2)
                jScoreTable.setValueAt("  " + scoreData.getGameScore(j, n), rowPointer, j * 2);

                //Honour
                if( n == upToGame ){
                    jScoreTable.setValueAt("  " + scoreData.getCharacterHonour(j), rowPointer, j * 2 + 1);
                }

                // last game of a round, so set the subtotal
                if (n % 4 == 3) {

                    //Score (use * 3 as a correction at team 2)
                    jScoreTable.setValueAt("  " + scoreData.getRoundScore(j, n / 4), rowPointer + 2, j * 2);

                    //Honour
                    jScoreTable.setValueAt("  " + scoreData.getRoundHonour(j, n / 4), rowPointer + 2, j * 2 + 1);

                }

                // set total score
                if (n == Match.NUMOFGAMES-1) {
                    //Score (use * 3 as a correction at team 2)
                    jScoreTable.setValueAt("  " + scoreData.getTotalScore(j), 33, j * 2);
                }

            }

            if (n % 4 == 3) rowPointer += 5;
            else rowPointer++;
        }

    }

    private void clearScoreTable() {
        jScoreTable.setFont(plainFont);

        for (int r=0; r<34; r++) {
            for (int c=0; c<4; c++) {
                if (c == 0) {
                    switch (r % 8) {
                        case 0:         // at rows 0, 8, 16, 24 and 32
                            if (r == 32) {
                                jScoreTable.setValueAt("Total", r, c);
                            } else {
                                jScoreTable.setValueAt("Round " + ((r / 8) + 1),
                                        r, c);                                
                            }
                        break;
                        case 5:         // at rows 5, 13, 21 and 29
                            jScoreTable.setValueAt(" Subtotal", r, c);
                        break;
                        default:
                            jScoreTable.setValueAt("", r, c);
                        break;
                    }
                } else {
                    jScoreTable.setValueAt("", r, c);
                }
            }
        }
    }
}
