/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Game;

/**
 *
 * Represents a hand.
 * @author T.T.M. van Schaijk
 */
public class Hand extends Pile{
    Game game;
    
    /**
     * Creates a pile of maximally 8 cards.
     */
    public Hand(Game game){
        super(8);
        this.game = game;
    }

    /**
     * Determines whether this has a trumpcard.
     * @return True if this has trump.
     */
    public boolean hasTrump(){
        boolean ret = false;
        for(int i=0; i<8; i++){
            if(super.getCard(i).getSuit() == game.getTrump()){
                ret = true;
            }
        }
        return ret;
    }

    public Pile getHigherTrumpCard(Card cardToCheck) {
        Pile ret = new Pile(8);

        for (int i = 0; i < this.getCardCount(); i++) {
            if (this.getCard(i).getSuit() == game.getTrump() &&
                this.getCard(i).getTrumpRank().ordinal() > cardToCheck.getTrumpRank().ordinal()) {
                ret.addCard(this.getCard(i));
            }
        }
        return ret;
    }

}