/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Game;

import Main.Main;

/**
 * Represents a human player.
 * @author T.T.M. van Schaijk
 */
public class Human extends Player {
    private boolean pop, honour;

    /**
     * Initializes the human.
     * @param pv A PlayView object. Used to enable buttons.
     * @param playerNumber The number of this player.
     * @param stock A Stock object. Used to fill the hand.
     * @param game Game object. Used to determine trump color.
     */
    public Human(int playerNumber, Stock stock, Game game){
        super(playerNumber, stock, game);
        this.pop = false;
        this.honour = false;
    }

    /**
     * Determines whether human wants to play or pass.
     * @return True if human wants to play.
     */
    @Override
    public boolean passOrPlay(){
        return Main.jFrameMain.cardView.passOrPlay();
    }

    /**
     * Lets human choose trump when all players pass.
     * @return Suit of selected trump.
     */
    @Override
    public Card.Suit chooseTrump(){
        return Main.jFrameMain.cardView.selectTrumpColour();
    }

    /**
     * Lets human choose a card to play.
     * @return The card human wants to play.
     */
    @Override
    public Card playCard(){
       Card card = Main.jFrameMain.cardView.playCard();
       super.getHand().removeCard(card);
       return card;
    }

    /**
     * Lets human decide whether or not to call honour.
     * @return True if human wants to call honour.
     */
    @Override
    public boolean promptHonour(){
        return Main.jFrameMain.cardView.promptHonour();
    }

    /**
     * Not used in Human
     */
    @Override
    public void startMatch() {
        Main.jFrameMain.cardView.setInfoText("Welcome to Klaverjassen. The " +
                "match\nwill begin shortly.");
    }

    /**
     * Not used in Human
     */
    @Override
    public void startGame() {
        Main.jFrameMain.cardView.setInfoText("Game " + 
                (game.getGameNumber()+1) + " starts. Player \"" + 
                Main.jFrameMain.mainMenu.getPlayerName(game.getGameLeader()) +
                "\"\nstarts the bidding.");
    }

    /**
     * Not used in Human
     */
    @Override
    public void startTrick(){}

    /**
     * Not used in Human
     */
    @Override
    public void endTrick(){}
}
