/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Game;
import java.util.EnumSet;

/**
 * The stock contains all cards that will at sometime be in play.
 * @author T.T.M. van Schaijk
 */
public class Stock extends Pile{

    Player[] players = {null,null,null,null};

    /**
     * Creates a pile, fills it and shuffles it.
     */
    public Stock(){
        // Contains 32 cards
        super(32);

        // Add all cards
        for(Card.Suit suit : Card.Suit.values()){
            for(Card.Rank rank : EnumSet.range(Card.Rank.SEVEN, Card.Rank.ACE)){
                super.addCard(new Card(rank, suit));
            }
        }

        // Shuffle cards
        super.shuffle();
    }

    /**
     * Sets the players in the game, used to deal.
     * @param players Array containing the players in the game.
     */
    public void setPlayers(Player[] players){
        System.arraycopy(players, 0, this.players, 0, 4);
    }

    /**
     * Deals the cards to all players.
     */
    public void deal(){
        for(int j=0; j<4; j++){
            players[j].fillHand();
        }
    }

    /**
     * Clears the stock and fills it with all 32 cards again.
     */
    public void reset(){
        super.empty();

        // Add all cards
        for(Card.Suit suit : Card.Suit.values()){
            for(Card.Rank rank : EnumSet.range(Card.Rank.SEVEN, Card.Rank.ACE)){
                super.addCard(new Card(rank, suit));
            }
        }

        // Shuffle cards
        super.shuffle();
    }

}
